Zoom

With SpreadJS you can zoom the worksheet view in and out for varying levels of detail. In addition, the zoom level can be controlled using ViewZooming and ViewZoomed events.

Zoom operations Ctrl + Mousewheel Status bar zoom indicator Double fingers operation, touchable only Use API sheet.zoom(zoomFactor) AllowUserZoom We provide a spread option called allowUserZoom to control whether sheet viewport could be zoomed: Get or set zoom factor through API ViewZooming / ViewZoomed Events In order to intervene in the zooming process on different worksheets / spreads instance, we provide two events: GC.Spread.Sheets.Events.ViewZooming The available arguments in its handler function: sheet: The sheet that triggered the event. sheetName: The sheet's name. newZoomFactor: The new zoom factor, user could make some change to intervene the real zoom action. oldZoomFactor: The old zoom factor. cancel: A value that indicates whether the operation should be canceled. GC.Spread.Sheets.Events.ViewZoomed The available arguments in its handler function: sheet: The sheet that triggered the event. sheetName: The sheet's name. newZoomFactor: The new zoom factor, user could make some change to intervene the real zoom action. oldZoomFactor: The old zoom factor.
window.onload = function() { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss")); initStatusBar(spread); initSpread(spread); initEvents(spread); }; function initStatusBar(spread) { var statusBarDOM = document.getElementById('statusBar'); var statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(statusBarDOM); statusBar.bind(spread); } function initSpread(spread) { var sheet = spread.getActiveSheet(); } function initEvents(spread) { var zoomFactorDOM = document.getElementById('zoomFactor'); var limitSwitch = document.getElementById('useLimit'); var maxZoomDOM = document.getElementById('maxZoom'); var minZoomDOM = document.getElementById('minZoom'); zoomFactorDOM.addEventListener('input', function() { var sheet = spread.getActiveSheet(); if (sheet) { var zoomFactor = parseFloat(this.value); var useLimit = limitSwitch.checked; var maxZoomFactor = parseFloat(maxZoomDOM.value), minZoomFactor = parseFloat(minZoomDOM.value); if (useLimit) { if (zoomFactor >= maxZoomFactor) { zoomFactor = maxZoomFactor; } if (zoomFactor <= minZoomFactor) { zoomFactor = minZoomFactor; } } zoomFactorDOM.value = zoomFactor; sheet.zoom(zoomFactor); } }); limitSwitch.addEventListener('change', syncDOM); spread.bind(GC.Spread.Sheets.Events.ViewZooming, function (e, args) { var useLimit = limitSwitch.checked; var maxZoomFactor = parseFloat(maxZoomDOM.value), minZoomFactor = parseFloat(minZoomDOM.value); if (useLimit) { if (args.newZoomFactor >= maxZoomFactor) { args.newZoomFactor = maxZoomFactor; } if (args.newZoomFactor <= minZoomFactor) { args.newZoomFactor = minZoomFactor; } } zoomFactorDOM.value = args.newZoomFactor; }); syncDOM(); } function syncDOM() { var limitSwitch = document.getElementById('useLimit'); var maxZoomDOM = document.getElementById('maxZoom'); var minZoomDOM = document.getElementById('minZoom'); var maxZoomParentDOM = maxZoomDOM.parentNode; var minZoomParentDOM = minZoomDOM.parentNode; var useLimit = limitSwitch.checked; if (useLimit) { maxZoomParentDOM.classList.remove('hide'); minZoomParentDOM.classList.remove('hide'); } else { maxZoomParentDOM.classList.add('hide'); minZoomParentDOM.classList.add('hide'); } }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div class="spread-container"> <div id="ss" class="sample-spreadsheets"></div> <div id="statusBar"></div> </div> <div class="options-container"> <div class="option-row"> <label>Slide to zoom active sheet:</label> <div class="input"> <label class="inline-label">0.25</label> <input id="zoomFactor" type="range" name="points" min="0.25" max="4" value="1" step="0.01"/> <label class="inline-label">4</label> </div> </div> <div class="option-row"> <input id="useLimit" type="checkbox" /> <label for="useLimit" class="inline-label">Limit the zoom factor</label> </div> <div class="option-row"> <label for="maxZoom">The max zoom factor:</label> <input id="maxZoom" type="number" min="0.25" max="4" value="4" step="0.1" /> </div> <div class="option-row"> <label for="minZoom">The min zoom factor:</label> <input id="minZoom" type="number" min="0.25" max="4" value="0.25" step="0.1" /> </div> </div> </div></body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .spread-container { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .sample-spreadsheets { width: 100%; height: calc(100% - 30px); } #statusBar { width: 100%; height: 30px; } .inline-label { display: inline-block; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } label { display: block; margin-bottom: 6px; } input[type=button] { margin-top: 6px; display: block; padding: 4px 6px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } .hide { display: none !important; } .inputbox input { display: inline-block; }

Zoom

With SpreadJS you can zoom the worksheet view in and out for varying levels of detail. In addition, the zoom level can be controlled using ViewZooming and ViewZoomed events.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.vue
index.html
Copy to CodeMine

Zoom operations

  • Ctrl + Mousewheel
  • Status bar zoom indicator
  • Double fingers operation, touchable only
  • Use API sheet.zoom(zoomFactor)

AllowUserZoom

We provide a spread option called allowUserZoom to control whether sheet viewport could be zoomed:

spread.options.allowUserZoom = true;

Get or set zoom factor through API

// Get zoom factor
sheet.zoom();
// Set zoom factor, between 0.25 ~ 4
sheet.zoom(zoomFactor);

ViewZooming / ViewZoomed Events

In order to intervene in the zooming process on different worksheets / spreads instance, we provide two events:

GC.Spread.Sheets.Events.ViewZooming

The available arguments in its handler function:

  • sheet: The sheet that triggered the event.
  • sheetName: The sheet's name.
  • newZoomFactor: The new zoom factor, user could make some change to intervene the real zoom action.
  • oldZoomFactor: The old zoom factor.
  • cancel: A value that indicates whether the operation should be canceled.

GC.Spread.Sheets.Events.ViewZoomed

The available arguments in its handler function:

  • sheet: The sheet that triggered the event.
  • sheetName: The sheet's name.
  • newZoomFactor: The new zoom factor, user could make some change to intervene the real zoom action.
  • oldZoomFactor: The old zoom factor.
// Sample: limit the zoom factor from 1 to 2
spread.bind(GC.Spread.Sheets.Events.ViewZooming, function(e, args) {
    if (args.newZoomFactor >=2) {
        args.newZoomFactor = 2;
    }
    if (args.newZoomFactor <= 1) {
        args.newZoomFactor = 1;
    }
});
Zoom operations Ctrl + Mousewheel Status bar zoom indicator Double fingers operation, touchable only Use API sheet.zoom(zoomFactor) AllowUserZoom We provide a spread option called allowUserZoom to control whether sheet viewport could be zoomed: Get or set zoom factor through API ViewZooming / ViewZoomed Events In order to intervene in the zooming process on different worksheets / spreads instance, we provide two events: GC.Spread.Sheets.Events.ViewZooming The available arguments in its handler function: sheet: The sheet that triggered the event. sheetName: The sheet's name. newZoomFactor: The new zoom factor, user could make some change to intervene the real zoom action. oldZoomFactor: The old zoom factor. cancel: A value that indicates whether the operation should be canceled. GC.Spread.Sheets.Events.ViewZoomed The available arguments in its handler function: sheet: The sheet that triggered the event. sheetName: The sheet's name. newZoomFactor: The new zoom factor, user could make some change to intervene the real zoom action. oldZoomFactor: The old zoom factor.
<template> <div class="sample-tutorial"> <div class="spread-container"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> <gc-worksheet></gc-worksheet> </gc-spread-sheets> <div id="statusBar"></div> </div> <div class="options-container"> <div class="option-row"> <label>Slide to zoom active sheet:</label> <div class="input"> <label class="inline-label">0.25</label> <input id="zoomFactor" type="range" name="points" min="0.25" max="4" step="0.01" v-model="setZoom" /> <label class="inline-label">4</label> </div> </div> <div class="option-row"> <input id="useLimit" type="checkbox" v-model="useLimit" /> <label for="useLimit" class="inline-label">Limit the zoom factor</label> </div> <div class="option-row" v-if="useLimit"> <label for="maxZoom">The max zoom factor:</label> <input id="maxZoom" type="number" min="0.25" max="4" step="0.1" v-model="maxZoom" /> </div> <div class="option-row" v-if="useLimit"> <label for="minZoom">The min zoom factor:</label> <input id="minZoom" type="number" min="0.25" max="4" step="0.1" v-model="minZoom" /> </div> </div> </div> </template> <script setup> import { ref, watch } from "vue"; import "@mescius/spread-sheets-vue"; import GC from '@mescius/spread-sheets'; let spreadRef = null; const useLimit = ref(false); const maxZoom = ref(4); const minZoom = ref(0.25); const setZoom = ref(1); watch(setZoom, (value) => { let spread = spreadRef; var sheet = spread.getActiveSheet(); if (sheet) { var zoomFactor = parseFloat(value); var maxZoomValue = parseFloat(maxZoom.value), minZoomValue = parseFloat(minZoom.value); if (useLimit.value) { if (zoomFactor >= maxZoomValue) { zoomFactor = maxZoomValue; } if (zoomFactor <= minZoomValue) { zoomFactor = minZoomValue; } } sheet.zoom(zoomFactor); setZoom.value = zoomFactor; } }); let initSpread = function (spread) { spreadRef = spread; initStatusBar(); initEvents(); } function initStatusBar() { var statusBarDOM = document.getElementById('statusBar'); var statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(statusBarDOM); statusBar.bind(spreadRef); } function initEvents() { spreadRef.bind(GC.Spread.Sheets.Events.ViewZooming, (e, args) => { var maxZoomValue = parseFloat(maxZoom.value), minZoomValue = parseFloat(minZoom.value); if (useLimit.value) { if (args.newZoomFactor >= maxZoomValue) { args.newZoomFactor = maxZoomValue; } if (args.newZoomFactor <= minZoomValue) { args.newZoomFactor = minZoomValue; } } setZoom.value = args.newZoomFactor; }); } </script> <style scoped> #app { height: 100%; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .spread-container { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .sample-spreadsheets { width: 100%; height: calc(100% - 30px); } #statusBar { width: 100%; height: 30px; } .inline-label { display: inline-block; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } label { display: block; margin-bottom: 6px; } input[type=button] { margin-top: 6px; display: block; padding: 4px 6px; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } .hide { display: none !important; } .inputbox input { display: inline-block; } </style>
<!DOCTYPE html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <title>SpreadJS VUE</title> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script> <script src="./systemjs.config.js"></script> <script src="./compiler.js" type="module"></script> <script> var System = SystemJS; System.import("./src/app.js"); System.import('$DEMOROOT$/en/lib/vue3/license.js'); </script> </head> <body> <div id="app"></div> </body> </html>
(function (global) { SystemJS.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, packageConfigPaths: [ './node_modules/*/package.json', "./node_modules/@mescius/*/package.json", "./node_modules/@babel/*/package.json", "./node_modules/@vue/*/package.json" ], map: { 'vue': "npm:vue/dist/vue.esm-browser.js", 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', "systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js", '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js' }, meta: { '*.css': { loader: 'systemjs-plugin-css' }, '*.vue': { loader: "../plugin-vue/index.js" } } }); })(this);

Zoom operations
Ctrl + Mousewheel
Status bar zoom indicator
Double fingers operation, touchable only
Use API sheet.zoom(zoomFactor)
AllowUserZoom
We provide a spread option called allowUserZoom to control whether sheet viewport could be zoomed:
Get or set zoom factor through API
ViewZooming / ViewZoomed Events
In order to intervene in the zooming process on different worksheets / spreads instance, we provide two events:
GC.Spread.Sheets.Events.ViewZooming
The available arguments in its handler function:
sheet: The sheet that triggered the event.
sheetName: The sheet's name.
newZoomFactor: The new zoom factor, user could make some change to intervene the real zoom action.
oldZoomFactor: The old zoom factor.
cancel: A value that indicates whether the operation should be canceled.
GC.Spread.Sheets.Events.ViewZoomed
The available arguments in its handler function:
sheet: The sheet that triggered the event.
sheetName: The sheet's name.
newZoomFactor: The new zoom factor, user could make some change to intervene the real zoom action.
oldZoomFactor: The old zoom factor.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import './styles.css';
const useState = React.useState;
export function AppFunc() {
const [spread, setSpread] = useState(null);
const [state, setState] = useState({
useLimit: false,
maxZoom: 4,
minZoom: 0.25,
zoomFactor: 1
});
const initSpread = (spread) => {
setSpread(spread);
initStatusBar(spread);
initEvents(spread);
}
const setZoomFactor = (value) => {
var sheet = spread.getActiveSheet();
if (sheet) {
var zoomFactor = parseFloat(value);
var maxZoom = parseFloat(state.maxZoom),
minZoom = parseFloat(state.minZoom);
if (state.useLimit) {
if (zoomFactor >= maxZoom) {
zoomFactor = maxZoom;
}
if (zoomFactor <= minZoom) {
zoomFactor = minZoom;
}
}
sheet.zoom(zoomFactor);
//setState(state=>({...state,...{ zoomFactor: zoomFactor }}));
setZoomFactorState(zoomFactor);
}
}
const setZoomFactorState = (zoomFactor) => {
setState(state => ({ ...state, ...{ zoomFactor: zoomFactor } }));
}
const setUseLimit = (value) => {
setState(state => ({ ...state, ...{ useLimit: value } }));
}
const setMaxZoom = (value) => {
setState(state => ({ ...state, ...{ maxZoom: value } }));
}
const setMinZoom = (value) => {
setState(state => ({ ...state, ...{ minZoom: value } }));
}
const initStatusBar = (spread) => {
const statusBarDOM = document.getElementById('statusBar');
const statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(statusBarDOM);
statusBar.bind(spread);
}
const initEvents = (spread) => {
spread.bind(GC.Spread.Sheets.Events.ViewZooming, (e, args) => {
var maxZoom = parseFloat(state.maxZoom),
minZoom = parseFloat(state.minZoom);
if (state.useLimit) {
if (args.newZoomFactor >= maxZoom) {
args.newZoomFactor = maxZoom;
}
if (args.newZoomFactor <= minZoom) {
args.newZoomFactor = minZoom;
}
}
//setState({ zoomFactor: args.newZoomFactor });
setZoomFactorState(args.newZoomFactor);
});
}
return (
<div class="sample-tutorial">
<div class="spread-container">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet></Worksheet>
</SpreadSheets>
</div>
<div id="statusBar"></div>
</div>
<PanelFunc
setting={state}
setZoomFactor={(value) => setZoomFactor(value)}
setUseLimit={(value) => setUseLimit(value)}
setMaxZoom={(value) => setMaxZoom(value)}
setMinZoom={(value) => setMinZoom(value)}
></PanelFunc>
</div>
);
}
function PanelFunc(props) {
return (
<div className="options-container">
<div className="options-row">
<label>Slide to zoom active sheet:</label>
<div class="input">
<label class="inline-label">0.25</label>
<input id="zoomFactor" type="range" name="points" min="0.25" max="4" step="0.01" value={props.setting.zoomFactor}
onInput={(e) => { props.setZoomFactor(parseFloat(e.target.value)) }} />
<label class="inline-label">4</label>
</div>
</div>
<div class="option-row">
<input id="useLimit" type="checkbox" checked={props.setting.useLimit} onChange={(e) => { props.setUseLimit(e.target.checked); }} />
<label for="useLimit" class="inline-label">Limit the zoom factor</label>
</div>
<div class="option-row" style={{ display: props.setting.useLimit ? 'block' : 'none' }}>
<label for="maxZoom">The max zoom factor:</label>
<input id="maxZoom" type="number" min="0.25" max="4" step="0.1" value={props.setting.maxZoom} onChange={(e) => props.setMaxZoom(parseFloat(e.target.value))} />
</div>
<div class="option-row" style={{ display: props.setting.useLimit ? 'block' : 'none' }}>
<label for="minZoom">The min zoom factor:</label>
<input id="minZoom" type="number" min="0.25" max="4" step="0.1" value={props.setting.minZoom} onChange={(e) => props.setMinZoom(parseFloat(e.target.value))} />
</div>
</div>
);
}
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import './styles.css';
const Component = React.Component, useState = React.useState;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.dataSource = dataSource;
this.autoGenerateColumns = false;
this.state = {
useLimit: false,
maxZoom: 4,
minZoom: 0.25,
zoomFactor: 1
};
}
render() {
return (
<div class="sample-tutorial">
<div class="spread-container">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet></Worksheet>
</SpreadSheets>
</div>
<div id="statusBar"></div>
</div>
<Panel
setting={this.state}
setZoomFactor={(value) => this.setZoomFactor(value)}
setUseLimit={(value) => this.setUseLimit(value)}
setMaxZoom={(value) => this.setMaxZoom(value)}
setMinZoom={(value) => this.setMinZoom(value)}
></Panel>
</div>
);
}
initSpread(spread) {
this.spread = spread;
this.initStatusBar();
this.initEvents();
}
setZoomFactor(value) {
let spread = this.spread;
var sheet = spread.getActiveSheet();
if (sheet) {
var zoomFactor = parseFloat(value);
var maxZoom = parseFloat(this.state.maxZoom),
minZoom = parseFloat(this.state.minZoom);
if (this.state.useLimit) {
if (zoomFactor >= maxZoom) {
zoomFactor = maxZoom;
}
if (zoomFactor <= minZoom) {
zoomFactor = minZoom;
}
}
sheet.zoom(zoomFactor);
this.setState({ zoomFactor: zoomFactor });
}
}
setUseLimit(value) {
this.setState({ useLimit: value });
}
setMaxZoom(value) {
this.setState({ maxZoom: value });
}
setMinZoom(value) {
this.setState({ minZoom: value });
}
initStatusBar() {
var statusBarDOM = document.getElementById('statusBar');
var statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(statusBarDOM);
statusBar.bind(this.spread);
}
initEvents() {
this.spread.bind(GC.Spread.Sheets.Events.ViewZooming, (e, args) => {
var maxZoom = parseFloat(this.state.maxZoom),
minZoom = parseFloat(this.state.minZoom);
if (this.state.useLimit) {
if (args.newZoomFactor >= maxZoom) {
args.newZoomFactor = maxZoom;
}
if (args.newZoomFactor <= minZoom) {
args.newZoomFactor = minZoom;
}
}
this.setState({ zoomFactor: args.newZoomFactor });
});
}
}
class Panel extends Component {
constructor(props) {
super(props);
}
render() {
return (
<div className="options-container">
<div className="options-row">
<label>Slide to zoom active sheet:</label>
<div class="input">
<label class="inline-label">0.25</label>
<input id="zoomFactor" type="range" name="points" min="0.25" max="4" step="0.01" value={this.props.setting.zoomFactor}
onInput={(e) => { this.props.setZoomFactor(parseFloat(e.target.value)) }} />
<label class="inline-label">4</label>
</div>
</div>
<div class="option-row">
<input id="useLimit" type="checkbox" checked={this.props.setting.useLimit} onChange={(e) => { this.props.setUseLimit(e.target.checked); }} />
<label for="useLimit" class="inline-label">Limit the zoom factor</label>
</div>
<div class="option-row" style={{ display: this.props.setting.useLimit ? 'block' : 'none' }}>
<label for="maxZoom">The max zoom factor:</label>
<input id="maxZoom" type="number" min="0.25" max="4" step="0.1" value={this.props.setting.maxZoom} onChange={(e) => { this.props.setMaxZoom(parseFloat(e.target.value)); }} />
</div>
<div class="option-row" style={{ display: this.props.setting.useLimit ? 'block' : 'none' }}>
<label for="minZoom">The min zoom factor:</label>
<input id="minZoom" type="number" min="0.25" max="4" step="0.1" value={this.props.setting.minZoom} onChange={(e) => { this.props.setMinZoom(parseFloat(e.target.value)); }} />
</div>
</div>
);
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.spread-container {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.sample-spreadsheets {
width: 100%;
height: calc(100% - 30px);
}
#statusBar {
width: 100%;
height: 30px;
}
.inline-label {
display: inline-block;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
display: block;
margin-bottom: 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
padding: 4px 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.hide {
display: none !important;
}
.inputbox input {
display: inline-block;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Zoom operations
Ctrl + Mousewheel
Status bar zoom indicator
Double fingers operation, touchable only
Use API sheet.zoom(zoomFactor)
AllowUserZoom
We provide a spread option called allowUserZoom to control whether sheet viewport could be zoomed:
Get or set zoom factor through API
ViewZooming / ViewZoomed Events
In order to intervene in the zooming process on different worksheets / spreads instance, we provide two events:
GC.Spread.Sheets.Events.ViewZooming
The available arguments in its handler function:
sheet: The sheet that triggered the event.
sheetName: The sheet's name.
newZoomFactor: The new zoom factor, user could make some change to intervene the real zoom action.
oldZoomFactor: The old zoom factor.
cancel: A value that indicates whether the operation should be canceled.
GC.Spread.Sheets.Events.ViewZoomed
The available arguments in its handler function:
sheet: The sheet that triggered the event.
sheetName: The sheet's name.
newZoomFactor: The new zoom factor, user could make some change to intervene the real zoom action.
oldZoomFactor: The old zoom factor.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: '100%',
height: 'calc(100% - 30px)'
};
useLimit = false;
maxZoom = 4;
minZoom = 0.25;
zoomFactor = 1;
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
this.initStatusBar();
this.initEvents();
}
setZoom($event) {
let spread = this.spread;
var sheet = spread.getActiveSheet();
if (sheet) {
var zoomFactor = parseFloat($event.target.value);
var maxZoom = parseFloat(this.maxZoom),
minZoom = parseFloat(this.minZoom);
if (this.useLimit) {
if (zoomFactor >= maxZoom) {
zoomFactor = maxZoom;
}
if (zoomFactor <= minZoom) {
zoomFactor = minZoom;
}
}
sheet.zoom(zoomFactor);
forceUpdate(document.querySelector('#zoomFactor'), zoomFactor);
}
}
initStatusBar() {
var statusBarDOM = document.getElementById('statusBar');
var statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(statusBarDOM);
statusBar.bind(this.spread);
}
initEvents() {
this.spread.bind(GC.Spread.Sheets.Events.ViewZooming, (e, args) => {
var maxZoom = parseFloat(this.maxZoom),
minZoom = parseFloat(this.minZoom);
if (this.useLimit) {
if (args.newZoomFactor >= maxZoom) {
args.newZoomFactor = maxZoom;
}
if (args.newZoomFactor <= minZoom) {
args.newZoomFactor = minZoom;
}
}
this.zoomFactor = args.newZoomFactor;
});
}
}
function forceUpdate(input, value) {
input.value = value;
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<div class="spread-container">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div id="statusBar"></div>
</div>
<div class="options-container">
<div class="option-row">
<label>Slide to zoom active sheet:</label>
<div class="input">
<label class="inline-label">0.25</label>
<input id="zoomFactor" type="range" name="points" min="0.25" max="4" step="0.01" [(ngModel)]="zoomFactor" (input)="setZoom($event)" />
<label class="inline-label">4</label>
</div>
</div>
<div class="option-row">
<input id="useLimit" type="checkbox" [(ngModel)]="useLimit" />
<label for="useLimit" class="inline-label">Limit the zoom factor</label>
</div>
<div class="option-row" *ngIf="useLimit">
<label for="maxZoom">The max zoom factor:</label>
<input id="maxZoom" type="number" min="0.25" max="4" step="0.1" [(ngModel)]="maxZoom" />
</div>
<div class="option-row" *ngIf="useLimit">
<label for="minZoom">The min zoom factor:</label>
<input id="minZoom" type="number" min="0.25" max="4" step="0.1" [(ngModel)]="minZoom" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.spread-container {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.sample-spreadsheets {
width: 100%;
height: calc(100% - 30px);
}
#statusBar {
width: 100%;
height: 30px;
}
.inline-label {
display: inline-block;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
display: block;
margin-bottom: 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
padding: 4px 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.hide {
display: none !important;
}
.inputbox input {
display: inline-block;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);